## pinball-table-gnu 0.0.20230219

=== debian/Makefile ===
#!/usr/bin/make -f
project?=pinball-table-gnu
sudo?=sudo
tarball?=${CURDIR}/../${project}_${version}.orig.tar.gz
export tarball
make?=${MAKE} -f debian/Makefile

version?=$(shell [ -r debian/changelog ] \
  && which dpkg-parsechangelog > /dev/null 2>&1 \
  && dpkg-parsechangelog | grep "Version:" \
  | sed -e "s/Version: \(.*\)-.*/\1/g" \
  || echo "0.0.0")


default: rule/debuild
	-sync

${tarball}:
	 tar cvfz "$@" \
--transform "s|^./|${project}-${version}/|" \
--exclude 'debian' --exclude-vcs \
.
	@ls -l $@

rule/tarball: ${tarball}
	@ls $^

rule/setup: /etc/debian_version
	${sudo} apt-get update -y
	${sudo} apt-get install -y \
build-essential \
dpkg-dev \
devscripts \
debhelper \
\
autoconf \
automake \
libtool-bin \
docbook-utils \
pinball-dev \
libsdl2-dev \
# EOL

rule/version:
	@echo ${version}
	-cat /etc/os-release
	${CC} --version
	${MAKE} --version
	aclocal --version
	autoconf --version
	automake --version
	libtool --version

rule/debuild: debian/rules
	@which ${@F} || ${make} ${@D}/setup
	[ "" != "${tarball}" ] || ${make} ${@D}/tarball
	@ls "${tarball}" 2>/dev/null || ${make} ${@D}/tarball
	${make} ${@D}/version
	${@F} -S -us -uc \
|| echo "# error: Try './debian/rules rule/setup' first"
	${@F} -S -us -uc
	${@F} -us -uc

-include rules

=== snap/image/Makefile ===
#!/usr/bin/make -f
# -*- makefile -*-
# ex: set tabstop=4 noexpandtab:
# SPDX-License-Identifier: GPL-2.0-or-later
# Copyright: Philippe Coval <https://purl.org/rzr/> - 2021+

default: archive
	-sync

project?= pinball-table-gnu

-include ~/bin/mk-private.mk

gadget?=pc
base?=core
base_version?=20
architecture?=amd64
channel?=${base_version}/edge

export architecture
name?=${project}-${base}${base_version}-${architecture}-${gadget}
developer_id?=$(shell snapcraft whoami \
	| grep 'developer-id:' | cut -d' ' -f2 \
	|| echo "TODO: https://ubuntu.com/core/docs/custom-images")
authority_id?=${developer_id}
brand_id?=${authority_id}
ubuntu_image_snap_options?=
# image_size?=3G
# ubuntu_image_snap_options+=--image-size ${image_size}
key?=default

all?=version
all+=pc
all+=pi

sudo?=sudo
fd_file?=/usr/share/OVMF/OVMF_CODE.fd

help:
	snap keys

all: ${all}
	-sync

setup/snap:
	snap list
	${sudo} snap install snapcraft --edge
	${sudo} snap install ubuntu-image --edge
	${sudo} snap refresh
	snap list
	snap info ${project}

${fd_file}:
	${sudo} apt-get install ovmf
	ls "$@"

snap/snapcraft.yaml:
	${@D} init

archive: ${name}.img.gz
	du -hs $<

${name}.json: ubuntu-image-${gadget}.json Makefile
	jq -M . $<
	sed -e "s|{architecture}|${architecture}|g" < $< \
	| jq -r '.["authority-id"] = "${authority_id}"' \
	| jq -r '.architecture = "${architecture}"' \
	| jq -r '.["brand-id"] = "${brand_id}"' \
	| sponge $@
	jq -M . $@

image: ${name}.img.gz
	du -hs $<

%.img: %.model
	-mv $@.manifest $@.manifest.prev.tmp
	ubuntu-image snap ${ubuntu_image_snap_options} -o $@ $<
	sort seed.manifest | tee $@.manifest
	rm seed.manifest
	-diff -u $@.manifest.prev.tmp $@.manifest
	du -hsc $@

%.model: %.json timestamp Makefile
	jq -M . $< | snap sign -k ${key} > $@.tmp
	mv $@.tmp $@

timestamp: ${name}.json
	jq -M . "$<" | sed \
-e "s|\"timestamp\": .*|\"timestamp\": \"$$(date -Iseconds --utc)\",|g" \
	| jq -M . > "$<.tmp"
	mv "$<.tmp" "$<"

clean:
	rm -fv *~ *.img *.img.gz *.model

%.img.gz: %.img
	rm -f "$@"
	du -hsc $<
	gzip -9 $<
	du -hsc $@

pc:
	${MAKE} gadget=$@ architecture=amd64

pi:
	${MAKE} gadget=$@ architecture=arm64

pi3:
	${MAKE} gadget=pi architecture=armhf

version:
	${MAKE} --version
	ubuntu-image --version
	snapcraft version
	snap --version
	jq --version

%.key.tmp:
	snap keys | grep "^${key}" \
	|| snap create-key ${key}
	snap keys | grep "^${key}" | awk '{ print $$2 }' | tee $@


register:
	snapcraft list | grep '^${project} ' && exit 1
	snapcraft whoami || snapcraft login
	snapcraft whoami | grep '^developer-id: ${developer_id}'
	snapcraft list | grep '^${project} ' || snapcraft register "${project}"
	snapcraft list | grep '^${project} '

${project}.reg.tmp:
	snapcraft list | grep '^${project} ' || ${MAKE} register
	snapcraft list | grep '^${project} ' | tee "$@"

key: ${project}.key.tmp
	ls $<

run/%: %.img ${fd_file}
	sudo qemu-system-x86_64 \
	-enable-kvm -smp 2 -m 1500 -cpu host \
	-device virtio-vga,virgl=on \
	-drive file=${fd_file},if=pflash,format=raw,unit=0,readonly=on \
	-device virtio-net-pci,netdev=net0 \
	-netdev user,id=net0,hostfwd=tcp::50022-:22,hostfwd=tcp::50080-:80 \
	-drive file=$<,format=raw

run: run/${name}


.PRECIOUS: \
	%.img \
	%.model \
#EOL

## pinball-table-gnu 0%2B0.0.20230219

=== debian/changelog ===
pinball-table-gnu (0+0.0.20230219-0.0.20230219+4+geb655e1) unstable; urgency=medium

  * WIP: debian: Release 0+0.0.20230219-0.0.20230219+4+geb655e1
    (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Tue, 28 Feb 2023 21:24:25 +0100

pinball-table-gnu (0+0.0.20200601+24+g89634c7-0.0.20200601+32+g8d094eb) unstable; urgency=medium

  * WIP: debian: Release 0+0.0.20200601+24+g89634c7-
    0.0.20200601+32+g8d094eb (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Thu, 19 Jan 2023 06:45:06 +0100

pinball-table-gnu (0+0.0.20200601+24+g89634c7-0.0.20200601+31+g8c36764) unstable; urgency=medium

  * WIP: debian: Release 0+0.0.20200601+24+g89634c7-
    0.0.20200601+31+g8c36764 (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Thu, 19 Jan 2023 06:43:35 +0100

pinball-table-gnu (0.0.0.20200601+4+ged8f501-0.0.20200601+5+g97b7a79) unstable; urgency=medium

  * WIP: debian: Release 0.0.0.20200601+4+ged8f501-
    0.0.20200601+5+g97b7a79 (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Fri, 18 Dec 2020 03:25:20 +0100

pinball-table-gnu (0.0.20200601-2) unstable; urgency=medium

  * Team upload
  * Source only upload

 -- Xavier Guimard <yadd@debian.org>  Sun, 18 Oct 2020 08:57:22 +0200

pinball-table-gnu (0.0.20200601-1) unstable; urgency=medium

  * Initial release (Closes: #961930)

 -- Philippe Coval <rzr@users.sf.net>  Mon, 01 Jun 2020 07:03:14 +0200

=== debian/control ===
Source: pinball-table-gnu
Maintainer: Philippe Coval <rzr@users.sf.net>
Section: games
Priority: optional
Build-Depends: debhelper-compat (= 13),
               autoconf,
               automake,
               libtool,
               libltdl-dev,
               libsdl2-dev,
               pinball-dev
Standards-Version: 4.5.0
Vcs-Browser: https://github.com/rzr/pinball-table-gnu/tree/debian/master
Vcs-Git: https://github.com/rzr/pinball-table-gnu.git -b debian/master
Homepage: https://github.com/rzr/pinball-table-gnu
Rules-Requires-Root: no

Package: pinball-table-gnu
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         pinball,
         pinball-table-gnu-data (= ${source:Version})
Enhances: pinball
Description: GNU Pinball table for emilia pinball
 Another pinball table to have fun, behaviour plugin.
 The table is dedicated to GNU project.
 It features multiballs, magnets and bumpers.

Package: pinball-table-gnu-data
Architecture: all
Depends: ${misc:Depends}
Description: GNU Pinball table data used by plugin
 Visual and sounds for Emilia's pinball's GNU table.
 It features multiballs, magnets and bumpers.
 The table is dedicated to GNU project.

Package: pinball-table-gnu-snapshot
Architecture: all
Section: utils
Depends: ${misc:Depends}, pinball-table-gnu (= ${source:Version})
Suggests: rzr
Priority: extra
Description: unreleased snapshot version
 TODO: Remove on issue and upgrade pinball-table-gnu

## pinball-table-gnu 0.0.0.20200601%2B4%2Bged8f501d

=== debian/changelog ===
pinball-table-gnu (0.0.0.20200601+4+ged8f501d-0.0.20200601+5+ga8cc6e22) unstable; urgency=medium

  * WIP: debian: Release 0.0.0.20200601+4+ged8f501d-
    0.0.20200601+5+ga8cc6e22 (snapshot)

 -- Philippe Coval <rzr@users.sf.net>  Fri, 07 Aug 2020 08:56:01 +0200

pinball-table-gnu (0.0.0-0) unstable; urgency=medium

  * Initial release (Closes: #961930)

 -- Philippe Coval <rzr@users.sf.net>  Mon, 23 Dec 2019 23:51:35 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,16 @@
 Maintainer: Philippe Coval <rzr@users.sf.net>
 Section: games
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: debhelper (>= 11),
                autoconf,
                automake,
                libtool,
                libltdl-dev,
-               libsdl2-dev,
+               libsdl1.2-dev,
                pinball-dev
-Standards-Version: 4.5.0
+Standards-Version: 4.1.3
 Vcs-Browser: https://github.com/rzr/pinball-table-gnu/tree/debian/master
-Vcs-Git: https://github.com/rzr/pinball-table-gnu.git -b debian/master
+Vcs-Git: https://github.com/rzr/pinball-table-gnu.git#debian/master
 Homepage: https://github.com/rzr/pinball-table-gnu
 Rules-Requires-Root: no

## pinball-table-gnu 0.0.20200601

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,14 @@
 Maintainer: Philippe Coval <rzr@users.sf.net>
 Section: games
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 13),
                autoconf,
                automake,
                libtool,
                libltdl-dev,
                libsdl1.2-dev,
                pinball-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.5.0
 Vcs-Browser: https://github.com/rzr/pinball-table-gnu/tree/debian/master
 Vcs-Git: https://github.com/rzr/pinball-table-gnu.git#debian/master
 Homepage: https://github.com/rzr/pinball-table-gnu
@@ -34,13 +34,3 @@
  Visual and sounds for Emilia's pinball's GNU table.
  It features multiballs, magnets and bumpers.
  The table is dedicated to GNU project.
-
-Package: pinball-table-gnu-snapshot
-Architecture: all
-Section: utils
-Depends: ${misc:Depends}, pinball-table-gnu (= ${source:Version})
-Suggests: rzr
-Priority: extra
-Description: unreleased snapshot version
- TODO: Remove on issue and upgrade pinball-table-gnu
-

## pinball-table-gnu 0.0.20230219

=== debian/changelog ===
pinball-table-gnu (0.0.20230219-1) unstable; urgency=medium

  [Sylvain Beucler]
  * Team upload
  * d/control: depend on SDL2-rewritten 'pinball' package
    (Closes: #1038533)

  [ Jelmer Vernooĳ ]
  * Use standard way of specifying Vcs-Git branch name.

  [ Philippe Coval ]
  * New upstream version:
    + debian: Bump to current standards
    + debian/watch: Look for tags
    + debian: Depends on SDL2
  * d/control: Update standards
  * d/gbp.conf: Based on upstream tag
  * d/control: Set Multi-Arch: foreign
  * d/control: Set team maintenance

 -- Sylvain Beucler <beuc@debian.org>  Fri, 30 Jun 2023 13:59:03 +0200

=== debian/control ===
Source: pinball-table-gnu
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Philippe Coval <rzr@users.sf.net>
Section: games
Priority: optional
Build-Depends: debhelper-compat (= 13),
               autoconf,
               automake,
               libtool,
               libltdl-dev,
               libsdl2-dev,
               pinball-dev (>= 0.3.20230219)
Standards-Version: 4.6.2
Vcs-Browser: https://github.com/rzr/pinball-table-gnu/tree/debian/master
Vcs-Git: https://github.com/rzr/pinball-table-gnu.git -b debian/master
Homepage: https://github.com/rzr/pinball-table-gnu
Rules-Requires-Root: no

Package: pinball-table-gnu
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         pinball (>= 0.3.20230219),
         pinball-table-gnu-data (= ${source:Version})
Enhances: pinball
Description: GNU Pinball table for emilia pinball
 Another pinball table to have fun, behaviour plugin.
 The table is dedicated to GNU project.
 It features multiballs, magnets and bumpers.

Package: pinball-table-gnu-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: GNU Pinball table data used by plugin
 Visual and sounds for Emilia's pinball's GNU table.
 It features multiballs, magnets and bumpers.
 The table is dedicated to GNU project.
